/*------------------------------------------------------------------------------
* correlator.c: mex function correlator
*
* 2010/10/15 0.1 new
*-----------------------------------------------------------------------------*/
#include "mex.h"

extern void correlator(int sat, double coff, double freq, double phi0,
                       const char *buff, double ts, int ns, int s, int nc,
                       double *I, double *Q);

/* mex interface -------------------------------------------------------------*/
extern void mexFunction(int nargout, mxArray *argout[], int nargin,
                        const mxArray *argin[])
{
    double coff,freq,phi0,ts,*I,*Q;
    char *buff;
    int sat,s,ns,nc;
    
    if (nargin<8||mxGetM(argin[0])<1||mxGetM(argin[1])<1||mxGetM(argin[2])<1||
        mxGetM(argin[3])<1||mxGetM(argin[4])<1||mxGetM(argin[5])<1||
        mxGetM(argin[6])<1||mxGetM(argin[7])<1||!mxIsInt8(argin[4])) {
        mexErrMsgTxt("argin error");
    }
    sat =(int)*mxGetPr(argin[0]); /* I: satellite number */
    coff=     *mxGetPr(argin[1]); /* I: code offset (chip) */
    freq=     *mxGetPr(argin[2]); /* I: frequency (Hz) */
    phi0=     *mxGetPr(argin[3]); /* I: phase offset (rad) */
    buff=      mxGetPr(argin[4]); /* I: sampling data */
    ts  =     *mxGetPr(argin[5]); /* I: sampling interval (s) */
    s   =(int)*mxGetPr(argin[6]); /* I: correlator spacing (sample) */
    nc  =(int)*mxGetPr(argin[7]); /* I: number of side correlator */
    
    ns  =mxGetN(argin[4]);
    
    argout[0]=mxCreateDoubleMatrix(1,1+2*nc,mxREAL);
    argout[1]=mxCreateDoubleMatrix(1,1+2*nc,mxREAL);
    
    /* I=(I_P,I_E1,I_L1,I_E2,I_L2,...), Q=(Q_P,...) */
    I   =     mxGetPr(argout[0]); /* O: correlator results I */
    Q   =     mxGetPr(argout[1]); /* O: correlator results Q */
    
    correlator(sat,coff,freq,phi0,buff,ts,ns,s,nc,I,Q);
}
