/*------------------------------------------------------------------------------
* gencode_e.c: generate code
*
* 2010/10/15 0.1 new
*-----------------------------------------------------------------------------*/
#include <stdio.h>

#define LEN_CA      1023        /* c/a code length */

/* ca code -------------------------------------------------------------------*/
static void cacode(int sat, short *code)
{
    const int delay[]={
          5,  6,  7,  8, 17, 18,139,140,141,251,252,254,255,256,257,258,
        469,470,471,472,473,474,509,512,513,514,515,516,859,860,861,862
    };
    char G1[LEN_CA],G2[LEN_CA],R1[10],R2[10],C1,C2;
    int i,j;
    
    for (i=0;i<10;i++) R1[i]=R2[i]=-1;
    for (i=0;i<LEN_CA;i++) {
        G1[i]=R1[9];
        G2[i]=R2[9];
        C1=R1[2]*R1[9];
        C2=R2[1]*R2[2]*R2[5]*R2[7]*R2[8]*R2[9];
        for (j=9;j>=0;j--) {
            R1[j+1]=R1[j];
            R2[j+1]=R2[j];
        }
        R1[0]=C1;
        R2[0]=C2;
    }
    for (i=0,j=LEN_CA-delay[sat-1];i<LEN_CA;i++,j++) {
        code[i]=-G1[i]*G2[j%LEN_CA];
    }
}
/* generate code -------------------------------------------------------------*/
extern void gencode(int sat, double coff, double cs, int ns, short *code)
{
    static short codes[32][LEN_CA]={{0}};
    double chip;
    short *p,*q,*r=code+ns;
    int i;
    
    if (sat<1||32<sat) {
        for (i=0;i<ns;i++) code[i]=0;
        return;
    }
    /* generate table */
    if (!codes[sat-1][0]) cacode(sat,codes[sat-1]);
    
    chip=-coff-cs;
    chip-=floor(chip/LEN_CA)*LEN_CA; /* 0<=chip<1023 */
    
    /* resampling */
    for (p=code,q=codes[sat-1];p<r;p++) {
        chip+=cs;
        if (chip>=LEN_CA) chip-=LEN_CA;
        *p=*(q+(int)chip);
    }
}
